#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <queue>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    vector<string> d(10);
    for (int i = 0; i < 10; i++) {
        cin >> d[i];
    }
    vector<int> cnt(5);
    for (int il = 0; il < 10; il++) {
        for (int jl = 0; jl < 10; jl++) {
            if (d[il][jl] == '.' || !((il == 0 || d[il - 1][jl] == '.') && (jl == 0 || d[il][jl - 1] == '.'))) {
                continue;
            }
            int ir = il, jr = jl;
            while (ir < 10 && d[ir][jl] == '#') {
                ir++;
            }
            ir--;
            while (jr < 10 && d[il][jr] == '#') {
                jr++;
            }
            jr--;
            if (ir > il && jr > jl) {
                cout << "NO";
                return 0;
            }
            if (ir > il) {
                if (ir - il + 1 > 4) {
                    cout << "NO";
                    return 0;
                }
                if (jl > 0) {
                    for (int ip = il - 1; ip <= ir + 1; ip++) {
                        if (ip >= 0 && ip < 10 && d[ip][jl - 1] == '#') {
                            cout << "NO";
                            return 0;
                        }
                    }
                }
                if (jl < 9) {
                    for (int ip = il - 1; ip <= ir + 1; ip++) {
                        if (ip >= 0 && ip < 10 && d[ip][jl + 1] == '#') {
                            cout << "NO";
                            return 0;
                        }
                    }
                }
                cnt[ir - il + 1]++;
                if (cnt[ir - il + 1] > 5 - (ir - il + 1)) {
                    cout << "NO";
                    return 0;
                }
            }


            if (jr > jl) {
                if (jr - jl + 1 > 4) {
                    cout << "NO";
                    return 0;
                }
                if (il > 0) {
                    for (int jp = jl - 1; jp <= jr + 1; jp++) {
                        if (jp >= 0 && jp < 10 && d[il - 1][jp] == '#') {
                            cout << "NO";
                            return 0;
                        }
                    }
                }
                if (il < 9) {
                    for (int jp = jl - 1; jp <= jr + 1; jp++) {
                        if (jp >= 0 && jp < 10 && d[il + 1][jp] == '#') {
                            cout << "NO";
                            return 0;
                        }
                    }
                }
                cnt[jr - jl + 1]++;
                if (cnt[jr - jl + 1] > 5 - (jr - jl + 1)) {
                    cout << "NO";
                    return 0;
                }
            }

        }
    }
    cout << "YES";
}

